/** Rational.java (Version .1)
 *  
 *  Eine Klasse rationaler Zahlen
 */

public class Rational {

   // Datenelemente
   private int num;	// Zaehler
   private int denom;   // Nenner


   // Konstruktoren
   public Rational() {
	num = 0;
	denom = 1;
   }

   public Rational(int n) {
	num = n;
	denom = 1;
   }

   public Rational(int numInit, int denomInit) {
	num = numInit;
	denom = denomInit;
   }


   // Methode: ggT von Zaehler und Nenner berechnen
   int gcd() {
	int x = num;
	int y = denom;

	if (num == 0) 
	   return denom;

        if (x < 0)
           x = -x;
        if (y < 0) 
           y = -y;

	while (x != y) 
           if (x > y)
                x = x - y;
           else
                y = y - x;
	return x;
   }
	
   // Methode: kuerzen
   public void reduce() {
	int gcd = gcd();
	num /= gcd;
	denom /= gcd;
   }

   // Methode: erweitern
   public void extend(int factor) {
	num *= factor;
	denom *= factor;
   }

   // Methode: ausgeben in der Form a/b
   public void output() {
	System.out.println(num + "/" + denom);
   }

   // Methode: gekuerzt ausgeben
   public void outputReduced() {
	reduce();
	output();
   }
}

// Rational.1
